-- xDownloader v1.0 #
-- Code & GFX par J3r3mie #
-- Merci  chardetm pour la fonction de tlchargement #
-- -----------------------------------------------------------

-- Disponible sous Creative Commons #
-- Informations : http://creativecommons.org/licenses/by-nc-nd/2.5/ca/deed.fr #
-- Veillez  la respecter #
-- -----------------------------------------------------------

--La librairie met la PSP  333MHZ
System.setHigh()

--Elle lit le oldpad
oldpad = Controls.read()

--Elle active le mode USB
--System.usbDiskModeActivate()

--Elle dfinit les couleurs
White = Color.new(255, 255, 255)
Red = Color.new(255, 0, 0)
Yellow = Color.new(255, 255, 0)
Teal = Color.new(0, 255, 255)
Green = Color.new(0, 255, 0)
Black = Color.new(0, 0, 0)
Brown = Color.new(127, 63, 0)
Blue = Color.new(0, 0, 255)
DarkBlue = Color.new(0, 0, 127)

-- Fonction pour afficher du texte avec un contour
function PrintTextOutline(PositionX,  PositionY,  Text,  TextColor,  OutlineColor)

	if PositionX == "Center" then
		PositionX = 240 - string.len(Text) * 5
	end

	screen:print(PositionX + 1, PositionY, Text, OutlineColor)
	screen:print(PositionX + 1, PositionY + 1, Text, OutlineColor)
	screen:print(PositionX, PositionY + 1, Text, OutlineColor)
	screen:print(PositionX - 1, PositionY, Text, OutlineColor)
	screen:print(PositionX - 1, PositionY - 1, Text, OutlineColor)
	screen:print(PositionX, PositionY - 1, Text, OutlineColor)
	screen:print(PositionX + 1, PositionY - 1, Text, OutlineColor)
	screen:print(PositionX - 1, PositionY + 1, Text, OutlineColor)

	screen:print(PositionX, PositionY, Text, TextColor)

end

--Fonction pour afficher du texte avec une ombre
function PrintTextShadow(PositionX,  PositionY,  Text,  TextColor,  ShadowColor, ShadowDistance)

	screen:print(PositionX + ShadowDistance, PositionY + ShadowDistance, Text, ShadowColor)
	screen:print(PositionX, PositionY, Text, TextColor)

end

function PrintFont(PositionX, PositionY, Text, TextColor, Size, CustomFont) 

	CustomFont:setPixelSizes(Size, Size)
	screen:fontPrint(CustomFont, PositionX, PositionY, Text, TextColor)

end

function Rafraichir()

screen.flip()
screen:waitVblankStart()

end

function Blit(PositionX, PositionY, Image)

screen:blit(PositionX, PositionY, Image);

end

function FindFirstSlash(String)

SlashPosition = 0

for i = 1, string.len(String) do

if string.sub(String, i, i) == '/' then SlashPosition = i break end

end

return SlashPosition

end

function FindLastSlash(String)

SlashPosition = 0

for i = 1, string.len(String) do

if string.sub(String, i, i) == '/' then SlashPosition = i end

end

return SlashPosition

end

--Merci  chardetm pour la fonction de tlchargements, modifi selon mes besoins
function Download(Server, File, Path, Name) 

	--Activation du WLAN
	Wlan.init()
	
	--Cration des variables
	local socket , error , bytesSent , header , a , b , len , pos ,file 
	
	--Connection au Socket
	socket, error = Socket.connect(Server, 80)
	
	--Jusqu'a ce que le Socket ne soit pas connect, on le met en pause
	while not socket:isConnected() do System.sleep(20) end
	
	Rafraichir()
	
	System.sleep(200)
	
	--On envoie les informations au serveur (Le fichier et l'adresse)
	bytesSent = socket:send("GET /"..File.." HTTP/1.0\r\n")
	bytesSent = socket:send("host: "..Server.."\r\n\r\n")
	
	--On cre le fichier sur la Memory Stick qui recevra les informations
	file = io.open(Path.."/"..Name,"w")
	header = ""
	
	
	while not string.find(header, "\r\n\r") do
      header = header .. socket:recv(2)
      screen.waitVblankStart()
    end
    if not string.find(header, "\r\n\r\n") then
      header = header .. socket:recv(1)
      screen.waitVblankStart()
    end
    a,b,len = string.find(header, "Content%-Length: (%d+)\r\n")
    a = nil;b = nil
    len = tonumber(len)
	fin = ""
	while fin == "" do
		pos = file:seek("cur")
		file:write(socket:recv(2624))
		file:flush()
		if System.getFileSize(Path..Name) >= len then
			file:close()
			Rafraichir()
			System.sleep(200) 
			fin = "ok" 
		end
			Rafraichir()
	end
	socket:close()
	return fin

end

function DoDatabase()

dofile(Root.."database.db")

NumberFile = table.getn(File);

for i = 1, NumberFile do

File[i].host = string.sub(File[i].link, 0, FindFirstSlash(File[i].link) - 1)
File[i].page = string.sub(File[i].link, FindFirstSlash(File[i].link) + 1, string.len(File[i].link))
File[i].fname = string.sub(File[i].link, FindLastSlash(File[i].link) + 1, string.len(File[i].link))

end

NumberPage = math.ceil(NumberFile / 5);

end
